--[[
   
   PSP Jezzball by JEK warpony@gmail.com

]]

ball1 = Image.load("jezzimg/ball1.png")
ball2 = Image.load("jezzimg/ball2.png")
ball3 = Image.load("jezzimg/ball3.png")
ball4 = Image.load("jezzimg/ball4.png")
background = Image.load("jezzimg/bg.png")
cross = Image.load("jezzimg/cross.png")

color1 = Color.new(132, 165, 189)
color = Color.new(132, 165, 189)
color_solid = Color.new(210,210,210)
black = Color.new(0, 0, 0)
white = Color.new(255, 255, 255)

offscreen = Image.createEmpty(480,272) 
offscreen:clear(black)

instr = true
timer = 1
gameOver = false

life = 2

math.randomseed(os.time())

--Board
rightedge = 470
leftedge = 10
topedge = 10
bottomedge = 260
percent_cleared = 0
offx = 8
offy = 4
board_width = 31
board_height = 17
board = {}
for i=1,board_width do
   board[i] = {},{}
   for j=1,board_height do
      board[i][j] = 0
   end
end


--Lines
line_x1 = 0
line_y1 = 0
line_x1_end = 0
line_y1_end = 0
shooting = false
shootingH = false

--Cross
x = 1
y = 1


--Ball
ball = {
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {},
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {},
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}
}
in_use = 2

ball[1].x = 11
ball[1].y=240
ball[1].xspeed = 5
ball[1].yspeed = 5
ball[1].rightedge = 470
ball[1].leftedge = 10
ball[1].topedge = 10
ball[1].bottomedge = 260
ball[1].bimage = ball2
ball[1].dirx = 1 --Right
ball[1].diry = 1 --Up

ball[2].x = 300
ball[2].y=100
ball[2].xspeed = 5
ball[2].yspeed = 5
ball[2].rightedge = 470
ball[2].leftedge = 10
ball[2].topedge = 10
ball[2].bottomedge = 260
ball[2].bimage = ball1
ball[2].dirx = 1 --Right
ball[2].diry = 1 --Up

function create_balls()
   in_use = in_use + 1

   r = math.random(4)
   if r == 1 then
      ball[in_use].bimage = ball1
   end
   if r == 2 then
      ball[in_use].bimage = ball2
   end
   if r == 3 then
      ball[in_use].bimage = ball3
   end
   if r == 4 then
      ball[in_use].bimage = ball4
   end

   ball[in_use].x = 22
   ball[in_use].y=240
   ball[in_use].xspeed = 5
   ball[in_use].yspeed = 5
   ball[in_use].rightedge = 470
   ball[in_use].leftedge = 20
   ball[in_use].topedge = 20
   ball[in_use].bottomedge = 260
   ball[in_use].dirx = 1 --Right
   ball[in_use].diry = 1 --Up
end

function translatePos(pos)
   pos = pos+0.5
   return math.ceil(pos/15)
end

function nextLevel()

   screen.waitVblankStart(65)

   --Reset board
   for i=1,board_width do
      board[i] = {},{}
      for j=1,board_height do
         board[i][j] = 0
      end
   end
   
   --Add one more ball
   if in_use < 101 then
      create_balls()
   end
   life = life + 1
   timer = 1
end

function getPercent()
   per = 0
   for i = 1, board_width do
      for j = 1, board_height do
         if board[i][j] > 0 then
            per = per + 1
         end
      end
   end
   per = (per*100)/527 --527 is total squares on the board!
   return per
end

function create_area(x1, x1_end, y1, y1_end)
   left = x1
   right = findRight(x1+1, y1)
   checkSquare(left, right, y1, y1_end)

   left = findLeft(x1-1, y1)
   right = x1
   checkSquare(left, right, y1, y1_end)
   for i = y1, y1_end do
      board[x1][i] = 1
   end  
end

function create_areaH(x1, x1_end, y1, y1_end)
   --findSolid()
   top = findTop(x1, y1-1)
   bottom = y1
   checkSquare(x1, x1_end, top, bottom)

   top = y1
   bottom = findBottom(x1, y1+1)
   checkSquare(x1, x1_end, top, bottom)
   for i = x1, x1_end do
      board[i][y1] = 2
   end  
end

function findLeft(x1, y1)
   left = 0
   for i = x1, 1, -1 do --Search from current xpos to the left
      if ((board[i][y1] == 1) or (board[i][y1] == 2)) and (left == 0) then
         left = i+1
      end
   end
   if left == 0 then
      left = 1
   end
   return left   
end

function findRight(x1, y1)
   right = 0
   for i = x1, board_width do --Search from current xpos to the right
      if ((board[i][y1] == 1) or (board[i][y1] == 2)) and (right == 0) then
         right = i-1
      end
   end
   if right == 0 then
      right = board_width
   end
   return right   
end

function findTop(x1, y1)
   top = 0
   for i = y1, 1, -1 do --Search from current ypos to the top
      if ((board[x1][i] == 1) or (board[x1][i] == 2)) and (top == 0) then
         top = i+1
      end
   end
   if top == 0 then
      top = 1
   end
   return top   
end

function findBottom(x1, y1)
   bottom = 0
   for i = y1, board_height do --Search from current ypos to the bottom
      if ((board[x1][i] == 1) or (board[x1][i] == 2)) and (bottom == 0) then
         bottom = i-1
      end
   end
   if bottom == 0 then
      bottom = board_height
   end
   return bottom
end

function shootLines()
   if line_x1 == 0 then
      line_x1 = x
      line_x1_end = x
      line_y1 = y
      line_y1_end = y
      line_top = findTop(line_x1, line_y1)
      line_bottom = findBottom(line_x1, line_y1)
   end

   if line_y1_end > line_top then
      line_y1_end = line_y1_end - 1
   end
   if line_y1 < line_bottom then
      line_y1 = line_y1 + 1
   end

   --Check if ball hits line when in motion
   for k = 1, in_use do
      if (translatePos(ball[k].x) == line_x1) and ((translatePos(ball[k].y) < line_y1) and (translatePos(ball[k].y) > line_y1_end)) then
         shooting = false
         life = life - 1
         line_x1 = 0
         line_x1_end = 0
         line_y1 = 0
         line_y1_end = 0
      end
   end

   if (line_y1 >= line_bottom) and (line_y1_end <= line_top) then
      shooting = false
      --Line was successfully completed. Time to create the new areas!
      create_area(line_x1, line_x1_end, line_top, line_bottom)
      line_x1 = 0
      line_x1_end = 0
      line_y1 = 0
      line_y1_end = 0
   end
end

function shootLinesH()
   if line_x1 == 0 then
      line_x1 = x
      line_x1_end = x
      line_y1 = y
      line_y1_end = y
      line_left = findLeft(line_x1, line_y1)
      line_right = findRight(line_x1, line_y1)
   end

   if line_x1_end < line_right then
      line_x1_end = line_x1_end + 1
   end
   if line_x1 > line_left then
      line_x1 = line_x1 - 1
   end

   --Check if ball hits line when in motion
   for k = 1, in_use do
      if (translatePos(ball[k].y) == line_y1) and ((translatePos(ball[k].x) > line_x1) and (translatePos(ball[k].x) < line_x1_end)) then
         shootingH = false
         life = life - 1
         line_x1 = 0
         line_x1_end = 0
         line_y1 = 0
         line_y1_end = 0
      end
   end

   if (line_x1 <= line_left) and (line_x1_end >= line_right) then
      shootingH = false
      --Line was successfully completed. Time to create the new areas!
      create_areaH(line_left, line_right, line_y1, line_y1_end)
      line_x1 = 0
      line_x1_end = 0
      line_y1 = 0
      line_y1_end = 0
   end
end

function checkSquare(left, right, top, bottom)
   ball_present = false
   for k = 1, in_use do
      if (translatePos(ball[k].x) >= left) and (translatePos(ball[k].x) <= right) and (translatePos(ball[k].y) >= top) and (translatePos(ball[k].y) <= bottom) then
         ball_present = true
      end
   end
   if ball_present == false then
      for s = left, right do
         for t = top, bottom do
            board[s][t] = 3
         end
      end
   end
end

function BallMove()
 for i = 1, in_use do
   ball[i].x = ball[i].x + ball[i].xspeed
   ball[i].y = ball[i].y + ball[i].yspeed

   if ball[i].x > ball[i].rightedge-15 then
      ball[i].x = ball[i].rightedge-15
      ball[i].xspeed = -ball[i].xspeed
      ball[i].dirx = -ball[i].dirx
   end
   if ball[i].x < ball[i].leftedge then
      ball[i].x = ball[i].leftedge
      ball[i].xspeed = -ball[i].xspeed
      ball[i].dirx = -ball[i].dirx
   end
   if ball[i].y > ball[i].bottomedge-15 then
      ball[i].y = ball[i].bottomedge-15
      ball[i].yspeed = -ball[i].yspeed
      ball[i].diry = -ball[i].diry
   end
   if ball[i].y < ball[i].topedge then
      ball[i].y = ball[i].topedge
      ball[i].yspeed = -ball[i].yspeed
      ball[i].diry = -ball[i].diry
   end

   bx = translatePos(ball[i].x)
   by = translatePos(ball[i].y)

   if ((board[bx][by] == 1) or (board[bx][by] == 2)) then
      if board[bx][by] == 1 then
         if ball[i].dirx == 1 then
            ball[i].x = bx*15-30
         end
         if ball[i].dirx == -1 then
            ball[i].x = bx*15+7
         end
         ball[i].xspeed = -ball[i].xspeed
         ball[i].dirx = -ball[i].dirx
      end
      if board[bx][by] == 2 then
         if ball[i].diry == 1 then
            ball[i].y = by*15-30
         end
         if ball[i].diry == -1 then
            ball[i].y = by*15+7
         end
         ball[i].yspeed = -ball[i].yspeed
         ball[i].diry = -ball[i].diry
      end
   end
 end

end

oldPad = Controls.read()

while true do
   offscreen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)

   --Draw Balls
   for i = 1, in_use do
      offscreen:blit(ball[i].x, ball[i].y, ball[i].bimage)
   end

   --Draw Areas
   for i = 1, board_width do
      for j = 1, board_height do
         if board[i][j] == 1 or board[i][j] == 2 then
            color = color1
            offscreen:fillRect(i*15-offx, j*15-offy, 15, 15, color)
         end
         if board[i][j] == 3 then
            color = color_solid
            offscreen:fillRect(i*15-offx, j*15-offy, 15, 15, color)
         end
      end
   end

   offscreen:blit(x*15-offx*2-2, y*15-offy*3, cross)

  
   BallMove()


   if shooting == true then
      shootLines()
      offscreen:drawLine(line_x1*15-offx, line_y1*15-offy, line_x1_end*15-offx, line_y1_end*15-offy, color)
   end
   if shootingH == true then
      shootLinesH()
      offscreen:drawLine(line_x1*15-offx, line_y1*15-offy, line_x1_end*15-offx, line_y1_end*15-offy, color)
   end


   percent_cleared = getPercent()
   offscreen:print(10, 1, "Cleared: "..math.ceil(percent_cleared).."%", black)
   offscreen:print(140, 1, "Lives: "..life, black)
   offscreen:print(230, 1, "Balls: "..in_use, black)
   if percent_cleared > 74 then --Just to get some time in between completion and message.
      timer = timer + 1
   end
   if percent_cleared > 74 and timer >= 10 then
      screen:fillRect(85, 75, 310, 110, black)
      screen:fillRect(90, 80, 300, 100, color1)
      screen:print(170, 100, "- Level Cleared -", black)
      screen:print(190, 140, "Get Ready...", black)
      screen:print(171, 101, "- Level Cleared -", white)
      screen:print(191, 141, "Get Ready...", white)
      screen.waitVblankStart()
      screen.flip()

      nextLevel()
   end

   if life < 1 then
      gameOver = true
      shootingH = false
      shooting = false
   end
   if gameOver == true then
      offscreen:fillRect(85, 75, 310, 110, black)
      offscreen:fillRect(90, 80, 300, 100, color1)
      offscreen:print(185, 110, "- Game Over -", black)
      offscreen:print(140, 140, "Press Square to restart!", black)
      offscreen:print(186, 111, "- Game Over -", white)
      offscreen:print(141, 141, "Press Square to restart!", white)
   end

	if instr == true then
       offscreen:print(80, 55, "PSP JezzBall By JEK - warpony@gmail.com", black)
       offscreen:print(81, 56, "PSP JezzBall By JEK - warpony@gmail.com", white)
       offscreen:print(175, 95, "- Instructions -", white)
       offscreen:print(70, 115, "Clear the board by isolating the balls from", white)
       offscreen:print(60, 130, " the rest of the board. To advance to the next", white)
       offscreen:print(65, 145, " level, you have to clear at least 75 percent.", white)
       
       offscreen:print(220, 170, "Keys:", white)
       offscreen:print(145, 185, "Circle - Divide left/right", white)
       offscreen:print(155, 200, "Cross - Divide up/down", white)
       offscreen:print(90, 230, "- Press TRIANGLE to start the game -", black)
	end

	pad = Controls.read()
	if pad ~= oldPad then
       if pad:start() then
         break
      end
      if pad:triangle() then
         if gameOver == false then
            instr = false
         end
      end
      if pad:circle() then
         if gameOver == false and shooting == false and shootingH == false and board[x][y] == 0  then
            instr = false
            shootingH = true
         end
      end
      if pad:cross() then
         if gameOver == false and shooting == false and shootingH == false and board[x][y] == 0 then
            instr = false
            shooting = true
         end
      end
      if pad:square() then
         instr = false
         if gameOver == true then
            gameOver = false
            life = 1
            in_use = 1
            screen:fillRect(85, 75, 310, 110, black)
            screen:fillRect(90, 80, 300, 100, color1)
            screen:print(190, 120, "Get Ready...", black)
            screen:print(191, 121, "Get Ready...", white)
            screen.waitVblankStart()
            screen.flip()
            nextLevel()
         end
      end
      if pad:up() then
         y = y - 1
         if y < 1 then
            y = board_height
         end
      end
      if pad:down() then
         y = y + 1
         if y > board_height then
            y = 1
         end
      end
      if pad:left() then
         x = x - 1
         if x < 1 then
            x = board_width
         end
      end
      if pad:right() then
         x = x + 1
         if x > board_width then
            x = 1
         end
      end
      --oldPad = pad
   end

   screen:blit(0, 0, offscreen, 0, 0, 480, 272, false)
   screen.waitVblankStart()
   screen.flip()

end

ball1 = nil
ball2 = nil
ball3 = nil
ball4 = nil
background = nil
cross = nil
offscreen = nil
board = nil
ball = nil


